---
updatedAt: 2026-09-22T20:16:11.000Z
agentTools:
  projectIndex: https://apidocs.klipfolio.com/llms.txt
---

# Data Source Instance Operations

Data source instance operations allow you to refresh a data source instance.

## POST /datasource-instances/\{id}/@/refresh

|              |                                                                                                                                                                                                                                                                                         |
| :----------- | :-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| Description  | Refresh the specified data source instance. This refresh operation queues the data source for refresh, but it does not necessarily refresh it instantly.                                                                                                                                |
| Permissions  | dashboard.library                                                                                                                                                                                                                                                                       |
| Resource URL | <https://app.klipfolio.com/api/1.0/datasource-instances/{id}/@/refresh>                                                                                                                                                                                                                 |
| Parameters   | id (string) - data source instance id<br />(optional) client\_id (string) - show only instances belonging to the specified client.<br />Note: The no\_refresh parameter creates a data source with no instance, then creates an instance that doesn't refresh and then push data to it. |

<br />

## Example Request

```text Refresh datasource instance
POST https://app.klipfolio.com/api/1/datasource-instances/0123456789abcdef0123456789abcdef/@/refresh
```
```text Client refresh datasource instance
```

## Example Response

```
{
"data": {
    "op_requested":"refresh"
},
"meta": {
   "status": 200,
   "success": true
}
}
```

## POST /datasources/@/refresh

<Table align={["left","left"]}>
  <thead>
    <tr>
      <th>

      </th>

      <th>

      </th>
    </tr>
  </thead>

  <tbody>
    <tr>
      <td>
        Description
      </td>

      <td>
        Queue multiple data sources for refresh in one API call.
      </td>
    </tr>

    <tr>
      <td>
        Permissions
      </td>

      <td>
        datasource.edit
      </td>
    </tr>

    <tr>
      <td>
        Resource URL
      </td>

      <td>
        [https://app.klipfolio.com/api/1.0/datasources/@/refresh](https://app.klipfolio.com/api/1.0/datasources/@/refresh)
      </td>
    </tr>

    <tr>
      <td>
        Parameters
      </td>

      <td>
        "datasources" : \["datasourceId1", "datasourceId2", ..., "datasourceIdN"]

        List the data source IDs in your request body.<br />(optional) client_id (string) - show only instances belonging to the specified client.
      </td>
    </tr>
  </tbody>
</Table>

## Example Request

```text Refresh many datasource instances
POST https://app.klipfolio.com/api/1.0/datasources/@/refresh {
"datasources" : ["1a12bc34de56abc12de3ab4c45de12a3", "2a12bc34de12abc12de3ab3c45de32a1", "3a12bc34de56cba32de1ab5c45de12b3"]
}
```
```text Client refresh many datasource instances
```

## Example Responses

```
{
    "meta": {
        "success": true,
        "status": 200
    },
    "data": {
        "op_requested": "refresh",
        "success": true,
        "total_datasources_requested": 3,
        "total_instances_requested": 5,
        "queue_status": 200,
        "total_instances_queued": 3,
}
}
```

```
{
    "meta": {
        "success": true,
        "status": 200
    },
    "data": {
        "op_requested": "refresh",
        "success": true,
        "total_datasources_requested": 2,
        "total_instances_requested": 1,
        "queue_status": 200,
        "total_instances_queued": 1,
        "failed_results": {
            "description": "Some datasources/instances failed to queue.",
            "invalid_datasources": {
                "1234a1b23bc4d12345abc1a123ab2a2c": {
                    "error": "Data source not found: 1234a1b23bc4d12345abc1a123ab2a2c",
                    "status": 404,
                    "success": false
                }
            }
        }
    }
}
```